



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Python - matplotlib 数据可视化</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Python - matplotlib 数据可视化</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-21 15:20:41 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>在许多实际问题中，经常要对给出的数据进行可视化，便于观察。</p>
<h3>今天专门针对Python中的数据可视化模块--matplotlib这块内容系统的整理，方便查找使用。</h3>
<h3>本文来自于对《利用python进行数据分析》以及网上一些博客的总结。</h3>
<h3>1 &nbsp;matplotlib简介</h3>
<div>matplotlib是Pythom可视化程序库的泰斗，经过几十年它仍然是Python使用者最常用的画图库。有许多别的程序库都是建立在它的基础上或直接调用它，比如pandas和seaborn就是matplotlib的外包，</div>
<div>它们让你使用更少的代码去使用matplotlib的方法。<a href="http://matplotlib.org/gallery.html" rel="external nofollow noreferrer">Gallery页面</a>中有上百幅缩略图，打开之后都有源程序，非常适合学习matplotlib。</div>
<div>&nbsp;</div>
<div>
<h3>2 &nbsp;图和子图的建立</h3>
<h4>2.1&nbsp; 导入matplotlib</h4>
<div>
<pre class="prettyprint linenums">import matplotlib.pyplot as plt<br />import numpy as np
</pre>
</div>
<p>　　</p>
<h4>2.2&nbsp;&nbsp;建立图和子图方式一</h4>
<h4>plt.plot( )会在最近的一个图上进行绘制</h4>
<div>
<pre class="prettyprint linenums">from numpy.random import randn<br />
fig = plt.figure(figsize = (8,4))    #设置图的大小<br />
ax1 = fig.add_subplot(2,2,1)<br />
ax2 = fig.add_subplot(2,2,2)<br />
ax3 = fig.add_subplot(2,1,2)<br />
ax3.plot(randn(50).cumsum(),'k--')   # plt.plot(randn(50).cumsum(),'k--')等效<br />
ax1.hist(randn(100),bins = 10, color = 'b', alpha = 0.3)      #bins 分成多少间隔   alpha 透明度<br />
ax2.scatter(np.arange(30),np.arange(30) + 3*randn(30))<br />
plt.show()
</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/822124/201804/822124-20180417213155604-82216591.png" /></p>
<h4>2.3&nbsp;建立子图方式二</h4>
<div>
<pre class="prettyprint linenums">from numpy.random import randn<br />
fig, axes = plt.subplots(2,2)                               #以数组方式访问<br />
t = np.arange(0., 5., 0.2)<br />
axes[0,0].plot(t, t, 'r-o', t, t**2, 'bs', t, t**3, 'g^')   #同时绘制多条曲线<br />
axes[1,1].plot(randn(40).cumsum(),'b--')<br />
plt.show()
</pre>
</div>
<p>　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/822124/201804/822124-20180417213318185-2090407684.png" /></p>
<h4>2.4&nbsp;主题设置</h4>
<p>使用style.use()函数</p>
<div>
<pre class="prettyprint linenums">df_iris = pd.read_csv('../input/iris.csv')<br />
plt.style.use('ggplot')    #'fivethirtyeight'，'ggplot'，'dark_background'，'bmh'<br />
df_iris.hist('sepal length')<br />
plt.show()
</pre>
</div>
<p>　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/822124/201804/822124-20180418090701322-413409508.png" /></p>
<h3>3 &nbsp;颜色、标记、线型、刻度、标签和图例</h3>
<div>
<pre class="prettyprint linenums">from numpy.random import randn<br />
fig = plt.figure()<br />
ax1 = fig.add_subplot(1,1,1)<br />
ax1.plot(randn(30).cumsum(),color = 'b',linestyle = '--',marker = 'o',label = '$cumsum$')  # 线型  可以直接'k--o'<br />
ax1.set_xlim(10,25)<br />
ax1.set_title('My first plot')<br />
ax1.set_xlabel('Stages')<br />
plt.legend(loc = 'best')           #把图放在不碍事的地方  xticks（[]）设置刻度<br />
plt.show()
</pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/822124/201804/822124-20180418090956988-213141548.png" /></p>
<p>等价于下面的代码：</p>
<div>
<pre class="prettyprint linenums">from numpy.random import randn<br />
fig = plt.figure()<br />
ax1 = fig.add_subplot(1,1,1)<br />
ax1.plot(randn(30).cumsum(),color = 'b',linestyle = '--',marker = 'o',label = '$cumsum$')   #图标可以使用latex内嵌公式<br />
plt.xlim(10,25)                   #plt.axis([10,25,0,10])对x,y轴范围同时进行设置<br />
plt.title('My first plot')<br />
plt.xlabel('Stages')<br />
plt.legend(loc = 'best')<br />
plt.show()
</pre>
</div>
<p>　　</p>
<div>
<h3>4 &nbsp;pandas中的绘图函数</h3>
</div>
<div>在pandas中，我们具有行标签，列标签以及分组信息。这也就是说，要制作一张完整的图表，原本需要一大堆的matplotlib代码，现在只需一两条简洁的语句就可以了。</div>
<div>pandas有很多能够利用DataFrame对象数据组织特点来创建标准图表的高级绘图方法。</div>
<div>&nbsp;</div>
<div>
<h4>4.1 &nbsp;线型图</h4>
<div>
<pre class="prettyprint linenums">from numpy.random import randn<br />
fig, axes = plt.subplots(1,2)<br />
s = pd.Series(randn(10).cumsum(),index = np.arange(0,100,10))<br />
s.plot(ax = axes[0])   # ax参数选择子图  

df = pd.DataFrame(randn(10,3).cumsum(0),columns = ['A','B','C'],index = np.arange(0,100,10))<br />
df.plot(ax = axes[1])<br />
plt.show()
</pre>
</div>
<p>　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/822124/201804/822124-20180418091330804-1804849544.png" /></p>
<h4>4.2 柱状图</h4>
<div>
<pre class="prettyprint linenums">from numpy.random import rand<br />
fig, axes = plt.subplots(1,2)<br />
data = pd.Series(rand(16),index = list('abcdefghijklmnop'))<br />
data.plot(kind = 'bar', ax = axes[0], color = 'b', alpha = 0.7)    #kind选择图表类型  'bar' 垂直柱状图<br />
data.plot(kind = 'barh', ax = axes[1], color = 'b', alpha = 0.7)   # 'barh' 水平柱状图<br />
plt.show()
</pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/822124/201804/822124-20180418091800594-2048701064.png" /></p>
<div>
<pre class="prettyprint linenums">from numpy.random import rand<br />
fig, axes = plt.subplots(1,2)<br />
data = pd.DataFrame(rand(6,4),<br />
                    index = ['one','two','three','four','five','six'],<br />
                    columns = pd.Index(['A','B','C','D'], name = 'Genus'))<br />
data.plot(kind = 'bar', ax = axes[0], alpha = 0.5)<br />
data.plot(kind = 'bar', ax = axes[1], stacked = True, alpha = 0.5)<br />
plt.show()
</pre>
</div>
<p><img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/822124/201804/822124-20180418091849305-1862999149.png" /></p>
<p>此外，柱状图有一个非常不错的用法，利用value_counts( )图形化显示Series中各值的出现概率，比如s.value_counts( ).plot(kind = 'bar')。</p>
<h4>4.3 直方图和密度图</h4>
<div>
<pre class="prettyprint linenums">from numpy.random import randn<br />
fig, axes = plt.subplots(1,2)<br />
data = pd.Series(randn(100))<br />
data.hist(ax = axes[0], bins = 50)       #直方图<br />
data.plot(kind = 'kde', ax = axes[1])    #密度图<br />
plt.show()
</pre>
</div>
<p>　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/822124/201804/822124-20180418092021735-1110561231.png" /></p>
<p>其实可以一次性制作多个直方图，layout参数的意思是将两个图分成两行一列，如果没有这个参数，默认会将全部的图放在同一行。</p>
<div>
<pre class="prettyprint linenums">df_iris = pd.read_csv('../input/iris.csv')<br />
columns = ['sepal length','sepal width','petal length','petal width']<br />
df_iris.hist(column=columns, layout=(2,2))<br />
plt.show()
</pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/822124/201804/822124-20180418092227125-1261263033.png" /></p>
<div><strong>4.4 箱型图</strong></div>
<div>箱型图是基于五数概括法（最小值，第一个四分位数，第一个四分位数（中位数），第三个四分位数，最大值）的数据的一个图形汇总，还需要用到四分位数间距IQR = 第三个四分位数 - 第一个四分位数。</div>
<div>
<div>
<pre class="prettyprint linenums">df_iris = pd.read_csv('../input/iris.csv')  #['sepal length','sepal width','petal length','petal width','class']<br />
sample_size = df_iris[['petal width','class']]<br />
sample_size.boxplot(by='class')<br />
plt.xticks(rotation=90)                     #将X轴的坐标文字旋转90度，垂直显示<br />
plt.show()
</pre>
</div>
<p>　　<img referrerpolicy="no-referrer"src="https://images2018.cnblogs.com/blog/822124/201804/822124-20180418092611502-557177053.png" /></p>
<h3>5 &nbsp;参考资料链接</h3>
<div>
<ul><li><a href="http://matplotlib.org/gallery.html" rel="external nofollow noreferrer">Gallery页面</a></li>
<li><a href="http://old.sebug.net/paper/books/scipydoc/matplotlib_intro.html" rel="external nofollow noreferrer">matplotlib&nbsp;&mdash;&nbsp;绘制精美的图表</a></li>
<li><a href="http://www.cnblogs.com/zhizhan/p/5615947.html" rel="external nofollow noreferrer">Python &mdash; matplotlib绘图可视化知识点整理</a></li>
<li><a href="http://blog.csdn.net/Veahlin/article/details/51941285" rel="external nofollow noreferrer">Python数据可视化之matplotlib学习笔记</a></li>
<li><strong>https://blog.csdn.net/qq_34264472/article/details/53814635&nbsp; &nbsp;(仅为记录，方便查找使用)</strong></li></ul>
</div>
</div>
<div>&nbsp;</div>
</div>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/e9jvlve9.html">异或链表&lpar;XOR linked list&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8kkwwr8.html">Atitit usbQb212 oo 面向对象封装的标准化与规范解决方案java c&num; php js</a>
		</li>
						<li><a href="https://www.batexi.com/a/390krwnq.html">vs xamarin android StartActivity</a>
		</li>
						<li><a href="https://www.batexi.com/a/390l0249.html">CloseHandle&lpar;IntPtr handle&rpar;抛异常</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2e51wq.html">MySQL 主从同步</a>
		</li>
						<li><a href="https://www.batexi.com/a/4952rde9.html">suricata学习笔记1--初步认识</a>
		</li>
						<li><a href="https://www.batexi.com/a/8z11rj39.html">用Jquery获取select的value和text值</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvz701q.html">第二百零一天 how can I坚持</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlm07j19.html">myeclipse配置svn亲测</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z7gv29.html">0X0000124</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjldd79.html">&lbrack;iOS&rsqb;数据库第三方框架FMDB详细讲解</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7zm5e19.html">young tableaus</a>
		</li>
						<li><a href="https://www.batexi.com/a/950px2z8.html">windows7旗舰版系统自带组件IIS搭建ftp</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpgm17q.html">ES6-模块化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpnrrxq.html">WCF消息交换模式之请求-响应模式</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mwv3o8.html">LBS&lpar;Location Based Service&rpar;&lpar;基于位置的服务&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/960znoy9.html">JavaWeb核心之Servlet</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj6evj9.html">Cortex-A15架构解析：它为什么这么强&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvx4px8.html">【WPF】Silverlight中的Action与Trigger</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ope3j8.html">Javac中的方法</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdj5rv0q.html">&lbrack;原&rsqb;openstack-kilo--issue&lpar;三&rpar; openstack-nova-issue-systemctl start openstack-nova-compute&period;service</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kom4ljq.html">Memcached下载安装、NET对Memcached进行CRUD操作（2）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8em026x9.html">jquery&period;fn&period;extend与jquery&period;extend用法与区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/ql1o21x9.html">python pytest测试框架介绍一</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwloewk9.html">&OpenCurlyDoubleQuote;找女神要QQ号码&rdquo;&mdash;&mdash;java篇</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnndk7jq.html">oracle fm格式化</a>
			</li>
						<li><a href="https://www.batexi.com/a/8mjd6pr8.html">iOS8新特性&lpar;1&rpar;&mdash;&mdash;UIAlertController</a>
			</li>
						<li><a href="https://www.batexi.com/a/q2kx1zwq.html">&lbrack;实战&rsqb;MVC5&plus;EF6&plus;MySql企业网盘实战&lpar;2&rpar;&mdash;&mdash;验证码</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jme7509.html">赋诗一首&amp;lt&semi;&amp;lt&semi;往事&amp;gt&semi;&amp;gt&semi;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8komzw5q.html">jQuery ajax的前台代码编写</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
